<CsoundSynthesizer>
<CsOptions>
-odac -Ma -b128 -B512 --midi-key=4 --midi-velocity-amp=5 -m0
</CsOptions>
<CsInstruments>

/******PLAYING DIFFERENT SCALES WITH DIFFERENT KEYBOARDS******/

;equal-tempered scale
giScale1 	ftgen 		1, 0, -12, -2,  0
;middle tone scale
giScale2 	ftgen 		2, 0, -12, -2,  0, -34, -7, 10, -14, 3, -21, -3, -27, -10, 7, -17
;pythagorean scale
giScale3 	ftgen 		3, 0, -12, -2,  0, 14, 4, -6, 8, -2, 12, 2, 16, 6, -4, 10
		massign 	0, 1

instr 1
ikey		=		p4
ivel		=		p5
;;SELECT SCALE BY CHANNEL
kchan1		invalue	"chan1"
kchan2		invalue	"chan2"
kchan3		invalue	"chan3"
kscale1	invalue	"scale1"
kscale2	invalue	"scale2"
kscale3	invalue	"scale3"
ichn		midichn
if ichn == i(kchan1) then
iscale		=		i(kscale1)
elseif ichn == i(kchan2) then
iscale		=		i(kscale2)
elseif ichn == i(kchan3) then
iscale		=		i(kscale3)
else
iscale		=		-1
endif
kreftone	invalue	"reftone"; any midi note number
ktunfreq	invalue	"tunfreq"; any frequency for it
kscale		invalue	"scale"; select scale by menu
ireftone	=		i(kreftone)
itunfreq	=		i(ktunfreq)
;;CALCULATION
icentdiff	=		1200 * logbtwo(itunfreq / cpsmidinn(ireftone)); centdifference tuning freq to usual freq
ishift		=		12 - (ireftone % 12)
indx		=		(ikey+ishift) % 12
icent		tab_i		indx, iscale; cent deviation according to function table 
ifreqeq	=		cpsmidinn(ikey); frequency for equal tempered and usual reference (a = 440 Hz)
ifreqeqtun	=		ifreqeq * cent(icentdiff); frequency for equal tempered on actual reference (tuning frequency)
ifreqscnorm	=		ifreqeq * cent(icent); frequency regarding cent deviations but usual reference (a = 440 Hz)
ifreqsctun	=		ifreqeq * cent(icent + icentdiff); frequency with correct cent deviations in scale and tuning pitch
anote		oscils		ivel, ifreqsctun, 0
kenv		linsegr	0, .1, 1, p3-0.1, 1, .1, 0
		out		anote * kenv
;;SHOW OUTPUT
Skey		sprintf	"%d", ikey
		outvalue	"key", Skey
if iscale == -1 then
		outvalue	"scale", "None!"
else
Schan		sprintf	"%d", iscale
		outvalue	"scale", Schan
endif
		outvalue	"centdiff",	 icentdiff
		outvalue	"cent", icent
		outvalue	"freqeq", ifreqeq
		outvalue	"freqscnorm", ifreqscnorm
		outvalue	"freqeqtun", ifreqeqtun
		outvalue	"freqsctun", ifreqsctun
endin
</CsInstruments>
<CsScore>
f 0 3600
e
</CsScore>
</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 642 90 401 510
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>
<MacGUI>
ioView background {43433, 43947, 32896}
ioText {242, 179} {80, 25} display 0.000000 0.00100 "key" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 55
ioText {66, 179} {174, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Key Pressed
ioText {243, 313} {80, 25} display 0.000000 0.00100 "cent" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder -50.0000
ioText {-1684371923, -1632653318} {227, 25} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation
ioText {245, 239} {78, 26} display 0.000000 0.00100 "freqeq" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 195.9867
ioText {13, 237} {225, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Usual Frequency of Key
ioText {245, 342} {78, 31} display 0.000000 0.00100 "freqscnorm" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 190.3966
ioText {13, 340} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency with Cent Deviation but usual Pitch Reference
ioText {245, 439} {78, 31} display 0.000000 0.00100 "freqsctun" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 191.6897
ioText {13, 437} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency with Cent Deviation and own Reference Frequency
ioText {245, 390} {78, 31} display 0.000000 0.00100 "freqeqtun" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 197.3178
ioText {13, 388} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency without Cent Deviation but with own Reference Frequency
ioText {5, 10} {392, 143} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {56832, 36608, 52736} nobackground border INPUT
ioText {7, 156} {320, 337} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground border OUTPUT
ioText {129, 104} {107, 26} editnum 443.000000 0.000001 "tunfreq" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 443.000000
ioText {121, 46} {123, 31} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Related Pitch
ioText {141, 73} {72, 27} label 0.000000 0.00100 "" center "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder (Hertz)
ioText {-610629723, -1632653302} {80, 25} display 0.000000 0.00100 "cent" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder -50.0000
ioText {-610629955, -1632653304} {227, 25} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation
ioText {13, 311} {225, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation because of Scale
ioText {244, 267} {80, 25} display 0.000000 0.00100 "centdiff" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 11.7287
ioText {16, 266} {222, 43} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder General Cent Deviation because of Tuning Reference
ioText {253, 10} {142, 46} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Select Scale by Midi Channels
ioText {255, 51} {63, 27} label 0.000000 0.00100 "" center "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Channel
ioText {318, 50} {69, 28} label 0.000000 0.00100 "" center "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Scale
ioText {261, 76} {55, 25} editnum 4.000000 1.000000 "chan1" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 4.000000
ioText {261, 100} {55, 25} editnum 2.000000 1.000000 "chan2" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 2.000000
ioText {261, 124} {55, 25} editnum 3.000000 1.000000 "chan3" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 3.000000
ioText {326, 77} {55, 25} editnum 1.000000 1.000000 "scale1" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 1.000000
ioText {326, 101} {55, 25} editnum 2.000000 1.000000 "scale2" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 2.000000
ioText {326, 125} {55, 25} editnum 3.000000 1.000000 "scale3" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 3.000000
ioText {241, 208} {80, 25} display 0.000000 0.00100 "scale" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 1
ioText {65, 208} {174, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Selected Scale (Table)
ioText {35, 106} {68, 26} editnum 69.000000 1.000000 "reftone" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 69.000000
ioText {20, 45} {90, 47} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Reference Tone
ioText {24, 85} {87, 25} label 0.000000 0.00100 "" center "Lucida Grande" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder (Midi-Number)
</MacGUI>

